杭電OJ 1973/哈理工OJ 1534 Prime Path(検索)bfs


Prime Path
Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 515    Accepted Submission(s): 337
Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .
Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 
Sample Input

   
   
   
   
3 1033 8179 1373 8017 1033 1033

 
Sample Output

   
   
   
   
6 7 0

 
この問題はまだ少し穴があいているので、頭がなくて問題をするのに細心の注意を払わない子供は注意しなければなりません~~~~
この問題はやはり簡単だ.しかし、操作が複雑で、操作を整理するときにエラーが発生しやすいので、ここではコードを最適化するために、時間がかかり、素数表を印刷するときに高速印刷方法を使用します.
        for(int j=2;j<sqrt(max);j++)
        {
            if(Is_or[j]==0)//       .
            for(int k=j+j;k<=max;k+=j)//    .(                     .)
            Is_or[k]=1;//       1    0;
        }
素数表があれば、変化した数字が素数かどうかを判断することができます.
ここでは広捜を利用しています.
完全なACコードを貼り付けます.
#include<stdio.h>
#include<queue>
#include<math.h>
#include<string.h>
using namespace std;
struct shusu
{
    int num[4];
    int output;
}now,nex;
#define max 10005
int Is_or[max];//0   
int mubiao[4];
int vis[10][10][10][10];//vis         .
char a[5];
char b[5];
void bfs()
{
    memset(vis,0,sizeof(vis));
    for(int i=0;i<4;i++)
    {
        now.num[i]=a[i]-'0';
        mubiao[i]=b[i]-'0';
    }
    now.output=0;
    vis[now.num[0]][now.num[1]][now.num[2]][now.num[3]]=1;
    queue<shusu>s;
    s.push(now);
    while(!s.empty())
    {
        now=s.front();
        //printf("%d%d%d%d",now.num[0],now.num[1],now.num[2],now.num[3]);
        if(now.num[0]==mubiao[0]&&now.num[1]==mubiao[1]&&now.num[2]==mubiao[2]&&now.num[3]==mubiao[3])
        {
            printf("%d
",now.output); return ; } s.pop(); for(int i=0;i<4;i++) { if(i==0) { for(int j=1;j<=9;j++)// , 0, 0, WA . { nex=now; if(j!=now.num[0]) nex.num[0]=j; int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0]; if(Is_or[sum]==0&&vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0) { //printf("%d
",sum); nex.output=now.output+1; s.push(nex); vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1; } } } if(i==1) { for(int j=0;j<=9;j++) { nex=now; if(j!=now.num[1]) nex.num[1]=j; int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0]; //printf("%d %d %d %d
",nex.num[0],nex.num[1],nex.num[2],nex.num[3]); if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0) { //printf("%d
",sum); nex.output=now.output+1; s.push(nex); vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1; } } } if(i==2) { for(int j=0;j<=9;j++) { nex=now; if(j!=now.num[2]) nex.num[2]=j; int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0]; if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0) { //printf("%d
",sum); nex.output=now.output+1; s.push(nex); vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1; } } } if(i==3) { for(int j=0;j<=9;j++) { nex=now; if(j!=now.num[3]) nex.num[3]=j; int sum=nex.num[3]+10*nex.num[2]+100*nex.num[1]+1000*nex.num[0]; if(Is_or[sum]==0&& vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]==0) { // printf("%d
",sum); nex.output=now.output+1; s.push(nex); vis[nex.num[0]][nex.num[1]][nex.num[2]][nex.num[3]]=1; } } } } } printf("Impossible
"); } int main() { int t; scanf("%d",&t); while(t--) { scanf("%s%s",a,b); // . for(int j=2;j<sqrt(max);j++) { if(Is_or[j]==0)// . for(int k=j+j;k<=max;k+=j)// .( .) Is_or[k]=1; } //printf("%d %d
",Is_or[1033],Is_or[1733]); bfs(); /*for(int i=1;i<50;i++) { printf("%d ",Is_or[i]); }*/ } }